package com.jiuqi.dna.ide.designer.commands;

import com.jiuqi.dna.ide.designer.elements.ICompositeElement;
import com.jiuqi.dna.ide.designer.elements.IFigureElement;
import org.eclipse.gef.commands.Command;

/* loaded from: com_jiuqi_dna_ide_designer_commands.jar:com/jiuqi/dna/ide/designer/commands/CompositeAddChildCommand.class */
public class CompositeAddChildCommand extends Command {
    private ICompositeElement parent;
    private ICompositeElement oldParent;
    private IFigureElement child;
    private IFigureElement after;
    private int index;
    private int oldIndex;

    public CompositeAddChildCommand(ICompositeElement parent, IFigureElement child, IFigureElement after) {
        this.index = -1;
        this.oldIndex = -1;
        this.parent = parent;
        this.child = child;
        this.oldParent = child.getParent();
        this.after = after;
        if (this.after != null) {
            this.index = parent.getChildIndex(this.after);
        }
        if (this.oldParent != null) {
            this.oldIndex = this.oldParent.getChildIndex(child);
        }
        setLabel("");
    }

    public boolean canExecute() {
        return super.canExecute();
    }

    public void execute() {
        this.child.dispose();
        this.child.setParent(this.parent);
        this.child.setInitChildIndex(this.index);
        this.child.init();
    }

    public void undo() {
        this.child.dispose();
        this.child.setParent(this.oldParent);
        this.child.setInitChildIndex(this.oldIndex);
        this.child.init();
    }
}
